;**********************************************
;*
;* 10 bits A/D converter demo
;*
;**********************************************

.include "..\include\1200def.inc"

.equ ADSC  =6      ; Start conversion bit
.equ ADLAR =5      ; Left adjust bit

.equ ADCSR =$06
.equ ADMUX =$07
.equ ADCL  =$04
.equ ADCH  =$05


;  Registers definitions
;
.def temp = r16

;**********************************************
;  Reset and interrupt vectors
;
.cseg
.org $00
   rjmp start        ; Go to Reset handler

.org $08
   rjmp ad_vector    ; ADC conversion vector


;***********************************************
; ADC complete interrupt service
;
ad_vector:

   in temp, ADCH
   reti

;***********************************************
;  Reset handler
;
start:
   ldi temp, $AB    ; Power on ADC; select prescaler (/8); free running
   out ADCSR,temp   ; and enable end of conversion interrupt
   sbi ADMUX, ADLAR ; Get 8 most significant bits in ADCL
   nop
   nop
   nop              ; Leave some time to stabilize before starting
   nop

   sbi ADCSR, ADSC  ; Go free runing and enable interrupts;
   sei              ; A warning must be issued here!!. 8 is not enough
                    ; as prescaler factor to obtain a 50-200 KHz
                    ; recommended ADC clock

forever:
   rjmp  forever  ; Infinite loop, interrupted by ADC conversions
