; ******************************************************
; Sleep mode simulation example
; ******************************************************

.include "..\include\4433def.inc"

; Test of sleep modes
;
.def  temp  =r16

; Define here Reset and interrupt vectors, if any
;
reset:
   rjmp start
   reti      ; Addr $01
   rjmp int1_service
   reti      ; Addr $03
   reti      ; Addr $04
   reti      ; Addr $05
   reti      ; Addr $06      Use 'rjmp myVector'
   reti      ; Addr $07      to define a interrupt vector
   reti      ; Addr $08
   reti      ; Addr $09
   reti      ; Addr $0A
   reti      ; Addr $0B
   reti      ; Addr $0C

; INT1 wake up the micro from the sleep status
;
int1_service:
   nop
   nop      ; When the MCU wakes up
   nop      ; comes here; place a
   nop      ; breakpoint to check it
   nop      ;
   nop
   reti

; Program starts here after Reset
;
start:
   ldi temp, low(RAMEND)
   out SPL,temp         ; Initialize Stackpointer

   ldi temp, $C0        ; Enable exeternal interrupts,
   out GIMSK, temp      ; that will wake up from sleep mode
   sei

forever:
   ldi temp, $3A   ;
   out MCUCR,temp  ; Enable sleep mode, select falling edge
   sleep
rjmp forever
