;******************************************************
;*
;* AVR UART example
;*
;*****************************************************

.include "..\include\2313def.inc"

.def tmp  =r16
.def j    =r17
.def k    =r18

; ***********************************************
;  Reset aand Interrupt vectors
; ***********************************************
.cseg
.org $0
    rjmp    start           ; Reset handler
.org URXCaddr               ; UART Receive Complete Interrupt
   rjmp uart_rx
.org UDREaddr               ; UART Data Register Empty Interrupt
   rjmp uart_em
.org UTXCaddr               ; UART Transmit Complete Interrupt
   rjmp uart_tx

; ************************************************
; UART RX service: it echoes the character into TX
; ************************************************
;
uart_rx:
   in tmp, UDR
   out UDR, tmp
   reti

uart_tx:   ;UART Transmission completed
   reti
uart_em:   ;UART data tx Empty
   reti

; ************************************************
; Main
; ************************************************
start:
   ldi tmp, 0x08          ; Activates watchdog
   wdr                    ; Always reset before
   out WDTCR, tmp         ;

   ldi tmp, 11            ; Set 9600 bauds for 1.8MHz
   out UBRR, tmp
   ldi tmp, 0xF8          ; To activate all interrupts and TX/RCV
   out UCR, tmp
   ldi   tmp,low(RAMEND)  ; initialize stack pointer
   out   SPL,tmp
   sei                    ; enable interrupts

   ldi   tmp,low(RAMEND)
   out   SPL,tmp          ; Initialize Stackpointer


; **************************************************
; Infinite loop, watchdog activation demonstrator
; **************************************************
forever:
   ldi j, 5               ; 5 times = "reasonable" delay

;   ldi j, 255            ; Uncommenting this line
                          ; will cause a too long delay,
                          ; and the Watchdog will actuate
loop1:
   rcall delay            ;
   dec j                  ;  delay: j times routine "delay"
   brne loop1

   wdr                    ; Watchdog reset, after a long delay
   rjmp forever           ;

delay:                    ; 255 cycles delay
   ldi k, 255             ;
loop2:                    ;
   dec k                  ;
   brne loop2             ;
   ret                    ;




