;***********************************************************
; SPI slave example
;
; After initialization of SPI as slave, it waits in
; a infinite loop. It catches interrupts coming from
; SPI, on transfer  complete
;***********************************************************

.include "..\include\4433def.inc"

.CSEG

; Reset and interrupt vectors
; ---------------------------
.org  0
   rjmp  Init
.org  SPIaddr        ;SPI Interrupt Vector Address
   rjmp  SPIcommIrpt

; Initializes stack pointer and SPI as slave
; ------------------------------------------
Init:
    ldi   XL,low(RAMEND)
    out   SPL,XL
    ldi   r16,(1<<SPIE)+(1<<SPE)+(1<<CPOL)+(1<<SPR1)
    out   SPCR,r16
    ser   r16
    out   SPDR,r16  ; Init data to all ones
    sei

forever:            ; Infinite loop
    rjmp  forever   ;

; SPI interrupt service
; ---------------------
SPIcommIrpt:
    in r16,SPSR      ; Retrieves the data from SPI data register

;   .............      process here the data received

    ldi   r16,$15    ; Data can be put now into shift-register.
    out   SPDR,r16   ; this data will be shifted out
                     ; to PB4 (MISO, if defined as output)
                     ; during next cycle.
    reti
