; *******************************************
; STEP02.ASM
;
; This step intends to explain how to use the Scope,
; so we need to do something in the I/O ports.
; Have a glance to the code and press the green light
; button.

.VERS "ST6210"
.ROMSIZE 2

.INPUT "regdef.h"  ; Registers include file

; RAM variables
; -------------

VAR_1   .DEF    084H,0FFH,0FFH,M
VAR_2   .DEF    085H,0FFH,0FFH,M

.ORG    0880H

; Reset point. Variables and ports initialization
; -----------------------------------------------
;

INIT
   LDI PA,    00001111b
   LDI PADIR, 00001111b ; PA0-PA are outputs
   LDI PAOR,  00001111b

   LDI VAR_1, 0
   LDI VAR_2, 255
   RETI

;                       * = TO DO's
;                       -----------

MAIN
   LDI WDT, 0FFH  ; * Did you remove this line?
   CALL SUB_1     ;   if not, do it now!
   INC VAR_1
   DEC VAR_2      ; Some doing-nothing stuff
   LD A, VAR_1
   LD PA, A       ; Just transfer the VAR_1 to port
   JP MAIN

SUB_1
   CALL SUB_2
   RET

SUB_2
   NOP
   RET
;
; TO DO's:
;   * Play with the Scope: change scales and move
;     with the horizontal scrollbar arrows.
;     ( Sorry, some commands in the scope are not yet
;     implemented ).
;   * When all is clear to you, close this project and
;     load step03.prj
;

; Interrupt vectors and RESET
; ----------------------------
;
.ORG 0FF0H

   NOP
   RETI
   NOP
   RETI
   NOP
   RETI
   NOP
   RETI

.ORG 0FFCH

   NOP
   RETI
   JP INIT     ; RESET vector
.END

